--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -15094,29 +16218,32 @@
 					rval = RD16_IO_REG(ha, mailbox_out[0]);
 					break;
 				}
-				if (CFG_IST(ha, CFG_CTRL_8021)) {
+				if (CFG_IST(ha, CFG_CTRL_82XX)) {
 					ql_8021_clr_hw_intr(ha);
 					ql_8021_clr_fw_intr(ha);
-				} else if (CFG_IST(ha, CFG_CTRL_242581)) {
+				} else if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 					WRT32_IO_REG(ha, hccr,
 					    HC24_CLR_RISC_INT);
 					RD32_IO_REG(ha, hccr);
 				} else {
+					WRT16_IO_REG(ha, semaphore, 0);
 					WRT16_IO_REG(ha, hccr,
 					    HC_CLR_RISC_INT);
+					RD16_IO_REG(ha, hccr);
 				}
 			}
 			drv_usecwait(5);
 		}
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
 			ql_8021_clr_hw_intr(ha);
 			ql_8021_clr_fw_intr(ha);
-		} else if (CFG_IST(ha, CFG_CTRL_242581)) {
+		} else if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			WRT32_IO_REG(ha, hccr, HC24_CLR_RISC_INT);
 			RD32_IO_REG(ha, hccr);
 		} else {
-			WRT16_IO_REG(ha, hccr, HC_CLR_RISC_INT);
 			WRT16_IO_REG(ha, semaphore, 0);
+			WRT16_IO_REG(ha, hccr, HC_CLR_RISC_INT);
+			RD16_IO_REG(ha, hccr);
 		}
 
 		if (timer == 0) {
@@ -15187,17 +16314,17 @@
 
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "(%d): no adapter\n",
+		QL_PRINT_2(NULL, "no adapter instance=%d\n",
 		    ddi_get_instance(dip));
 		return (DDI_FAILURE);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/*LINTED [Solaris DDI_DEV_T_ANY Lint warning]*/
 	if (ddi_prop_exists(DDI_DEV_T_ANY, dip, DDI_PROP_DONTPASS, prop) ==
 	    1) {
-		QL_PRINT_2(CE_CONT, "(%d): no prop exit\n", ha->instance);
+		QL_PRINT_2(ha, "no prop exit\n");
 		return (DDI_SUCCESS);
 	}
 
@@ -15237,7 +16364,7 @@
 		return (DDI_FAILURE);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
@@ -15252,18 +16379,18 @@
 
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "(%d): no adapter\n",
+		QL_PRINT_2(NULL, "no adapter instance=%d\n",
 		    ddi_get_instance(dip));
 		return (DDI_FAILURE);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/*LINTED [Solaris DDI_DEV_T_ANY Lint warning]*/
 	if (ddi_prop_lookup_byte_array(DDI_DEV_T_ANY, dip,
 	    DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, prop,
 	    (uchar_t **)&chs_p, &elements) != DDI_PROP_SUCCESS) {
-		QL_PRINT_2(CE_CONT, "(%d): no prop exit\n", ha->instance);
+		QL_PRINT_2(ha, "no prop exit\n");
 		return (DDI_FAILURE);
 	}
 
@@ -15300,7 +16427,7 @@
 		    QL_NAME, ddi_get_instance(dip), prop);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
@@ -15411,13 +16538,14 @@
 static void
 ql_halt(ql_adapter_state_t *ha, int pwr)
 {
-	uint32_t	cnt;
+	ql_link_t	*link;
+	ql_response_q_t	*rsp_q;
 	ql_tgt_t	*tq;
 	ql_srb_t	*sp;
+	uint32_t	cnt, i;
 	uint16_t	index;
-	ql_link_t	*link;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Wait for all commands running to finish. */
 	for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
@@ -15442,16 +16570,18 @@
 			}
 
 			/* Finish any commands waiting for more status. */
-			if (ha->status_srb != NULL) {
-				sp = ha->status_srb;
-				ha->status_srb = NULL;
-				sp->cmd.next = NULL;
-				ql_done(&sp->cmd);
+			for (i = 0; i < ha->rsp_queues_cnt; i++) {
+				if ((rsp_q = ha->rsp_queues[i]) != NULL &&
+				    (sp = rsp_q->status_srb) != NULL) {
+					rsp_q->status_srb = NULL;
+					sp->cmd.next = NULL;
+					ql_done(&sp->cmd, B_FALSE);
+				}
 			}
 
 			/* Abort commands that did not finish. */
 			if (cnt == 0) {
-				for (cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS;
+				for (cnt = 1; cnt < ha->osc_max_cnt;
 				    cnt++) {
 					if (ha->pending_cmds.first != NULL) {
 						ql_start_iocb(ha, NULL);
@@ -15459,10 +16589,14 @@
 					}
 					sp = ha->outstanding_cmds[cnt];
 					if (sp != NULL &&
+					    sp != QL_ABORTED_SRB(ha) &&
 					    sp->lun_queue->target_queue ==
 					    tq) {
-						(void) ql_abort((opaque_t)ha,
-						    sp->pkt, 0);
+						(void) ql_abort_io(ha, sp);
+						sp->pkt->pkt_reason =
+						    CS_ABORTED;
+						sp->cmd.next = NULL;
+						ql_done(&sp->cmd, B_FALSE);
 					}
 				}
 			}
@@ -15481,16 +16615,20 @@
 	ha->watchdog_timer = 0;
 	ADAPTER_STATE_UNLOCK(ha);
 
-	if (pwr == PM_LEVEL_D3) {
+	if (pwr == PM_LEVEL_D3 && ha->flags & ONLINE) {
 		ADAPTER_STATE_LOCK(ha);
 		ha->flags &= ~ONLINE;
 		ADAPTER_STATE_UNLOCK(ha);
 
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			ql_8021_clr_drv_active(ha);
+		}
+
 		/* Reset ISP chip. */
 		ql_reset_chip(ha);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -15514,11 +16652,11 @@
 {
 	int	rval;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	mem->size = size;
 	mem->type = allocation_type;
-	mem->cookie_count = 1;
+	mem->max_cookie_count = 1;
 
 	switch (alignment) {
 	case QL_DMA_DATA_ALIGN:
@@ -15537,12 +16675,34 @@
 		EL(ha, "failed, alloc_phys=%xh\n", rval);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
 
 /*
+ * ql_free_dma_resource
+ *	Function used to free dma memory.
+ *
+ * Input:
+ *	ha:		adapter state pointer.
+ *	mem:		pointer to dma memory object.
+ *	mem->dma_handle	DMA memory handle.
+ *
+ * Context:
+ *	Kernel context.
+ */
+void
+ql_free_dma_resource(ql_adapter_state_t *ha, dma_mem_t *mem)
+{
+	QL_PRINT_3(ha, "started\n");
+
+	ql_free_phys(ha, mem);
+
+	QL_PRINT_3(ha, "done\n");
+}
+
+/*
  * ql_alloc_phys
  *	Function used to allocate memory and zero it.
  *	Memory is below 4 GB.
@@ -15557,7 +16717,7 @@
  *	mem->alignment		memory alignment.
  *
  * Returns:
- *	qn local function return status code.
+ *	ql local function return status code.
  *
  * Context:
  *	Kernel context.
@@ -15566,16 +16726,13 @@
 ql_alloc_phys(ql_adapter_state_t *ha, dma_mem_t *mem, int sleep)
 {
 	size_t			rlen;
-	ddi_dma_attr_t		dma_attr;
+	ddi_dma_attr_t		dma_attr = ha->io_dma_attr;
 	ddi_device_acc_attr_t	acc_attr = ql_dev_acc_attr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	dma_attr = CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING) ?
-	    ql_64bit_io_dma_attr : ql_32bit_io_dma_attr;
-
 	dma_attr.dma_attr_align = mem->alignment; /* DMA address alignment */
-	dma_attr.dma_attr_sgllen = (int)mem->cookie_count;
+	dma_attr.dma_attr_sgllen = (int)mem->max_cookie_count;
 
 	/*
 	 * Workaround for SUN XMITS buffer must end and start on 8 byte
@@ -15647,6 +16804,15 @@
 
 	mem->flags |= DDI_DMA_RDWR;
 
+	if (qlc_fm_check_dma_handle(ha, mem->dma_handle)
+	    != DDI_FM_OK) {
+		EL(ha, "failed, ddi_dma_addr_bind_handle\n");
+		ql_free_phys(ha, mem);
+		qlc_fm_report_err_impact(ha,
+		    QL_FM_EREPORT_DMA_HANDLE_CHECK);
+		return (QL_MEMORY_ALLOC_FAILED);
+	}
+
 	if (ql_bind_dma_buffer(ha, mem, sleep) != DDI_DMA_MAPPED) {
 		EL(ha, "failed, ddi_dma_addr_bind_handle\n");
 		ql_free_phys(ha, mem);
@@ -15653,7 +16819,7 @@
 		return (QL_MEMORY_ALLOC_FAILED);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -15672,14 +16838,18 @@
 void
 ql_free_phys(ql_adapter_state_t *ha, dma_mem_t *mem)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (mem != NULL && mem->dma_handle != NULL) {
-		ql_unbind_dma_buffer(ha, mem);
+	if (mem != NULL) {
+		if (mem->memflags == DDI_DMA_MAPPED) {
+			ql_unbind_dma_buffer(ha, mem);
+		}
+
 		switch (mem->type) {
 		case KERNEL_MEM:
 			if (mem->bp != NULL) {
 				kmem_free(mem->bp, mem->size);
+				mem->bp = NULL;
 			}
 			break;
 		case LITTLE_ENDIAN_DMA:
@@ -15688,97 +16858,22 @@
 			if (mem->acc_handle != NULL) {
 				ddi_dma_mem_free(&mem->acc_handle);
 				mem->acc_handle = NULL;
+				mem->bp = NULL;
 			}
 			break;
 		default:
 			break;
 		}
-		mem->bp = NULL;
-		ddi_dma_free_handle(&mem->dma_handle);
-		mem->dma_handle = NULL;
+		if (mem->dma_handle != NULL) {
+			ddi_dma_free_handle(&mem->dma_handle);
+			mem->dma_handle = NULL;
+		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
- * ql_alloc_dma_resouce.
- *	Allocates DMA resource for buffer.
- *
- * Input:
- *	ha:			adapter state pointer.
- *	mem:			pointer to dma memory object.
- *	sleep:			KM_SLEEP/KM_NOSLEEP flag.
- *	mem->cookie_count	number of segments allowed.
- *	mem->type		memory allocation type.
- *	mem->size		memory size.
- *	mem->bp			pointer to memory or struct buf
- *
- * Returns:
- *	qn local function return status code.
- *
- * Context:
- *	Kernel context.
- */
-int
-ql_alloc_dma_resouce(ql_adapter_state_t *ha, dma_mem_t *mem, int sleep)
-{
-	ddi_dma_attr_t	dma_attr;
-
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	dma_attr = CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING) ?
-	    ql_64bit_io_dma_attr : ql_32bit_io_dma_attr;
-	dma_attr.dma_attr_sgllen = (int)mem->cookie_count;
-
-	/*
-	 * Allocate DMA handle for command.
-	 */
-	if (ddi_dma_alloc_handle(ha->dip, &dma_attr, (sleep == KM_SLEEP) ?
-	    DDI_DMA_SLEEP : DDI_DMA_DONTWAIT, NULL, &mem->dma_handle) !=
-	    DDI_SUCCESS) {
-		EL(ha, "failed, ddi_dma_alloc_handle\n");
-		mem->dma_handle = NULL;
-		return (QL_MEMORY_ALLOC_FAILED);
-	}
-
-	mem->flags = DDI_DMA_RDWR | DDI_DMA_CONSISTENT;
-
-	if (ql_bind_dma_buffer(ha, mem, sleep) != DDI_DMA_MAPPED) {
-		EL(ha, "failed, bind_dma_buffer\n");
-		ddi_dma_free_handle(&mem->dma_handle);
-		mem->dma_handle = NULL;
-		return (QL_MEMORY_ALLOC_FAILED);
-	}
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
-	return (QL_SUCCESS);
-}
-
-/*
- * ql_free_dma_resource
- *	Frees DMA resources.
- *
- * Input:
- *	ha:		adapter state pointer.
- *	mem:		pointer to dma memory object.
- *	mem->dma_handle	DMA memory handle.
- *
- * Context:
- *	Kernel context.
- */
-void
-ql_free_dma_resource(ql_adapter_state_t *ha, dma_mem_t *mem)
-{
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	ql_free_phys(ha, mem);
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-}
-
-/*
  * ql_bind_dma_buffer
  *	Binds DMA buffer.
  *
@@ -15785,9 +16880,9 @@
  * Input:
  *	ha:			adapter state pointer.
  *	mem:			pointer to dma memory object.
- *	sleep:			KM_SLEEP or KM_NOSLEEP.
+ *	kmflags:		KM_SLEEP or KM_NOSLEEP.
  *	mem->dma_handle		DMA memory handle.
- *	mem->cookie_count	number of segments allowed.
+ *	mem->max_cookie_count	number of segments allowed.
  *	mem->type		memory allocation type.
  *	mem->size		memory size.
  *	mem->bp			pointer to memory or struct buf
@@ -15804,36 +16899,29 @@
  *	Kernel context.
  */
 static int
-ql_bind_dma_buffer(ql_adapter_state_t *ha, dma_mem_t *mem, int sleep)
+ql_bind_dma_buffer(ql_adapter_state_t *ha, dma_mem_t *mem, int kmflags)
 {
-	int			rval;
 	ddi_dma_cookie_t	*cookiep;
-	uint32_t		cnt = mem->cookie_count;
+	uint32_t		cnt;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (mem->type == STRUCT_BUF_MEMORY) {
-		rval = ddi_dma_buf_bind_handle(mem->dma_handle, mem->bp,
-		    mem->flags, (sleep == KM_SLEEP) ? DDI_DMA_SLEEP :
-		    DDI_DMA_DONTWAIT, NULL, &mem->cookie, &mem->cookie_count);
-	} else {
-		rval = ddi_dma_addr_bind_handle(mem->dma_handle, NULL, mem->bp,
-		    mem->size, mem->flags, (sleep == KM_SLEEP) ?
-		    DDI_DMA_SLEEP : DDI_DMA_DONTWAIT, NULL, &mem->cookie,
-		    &mem->cookie_count);
-	}
+	mem->memflags = ddi_dma_addr_bind_handle(mem->dma_handle, NULL,
+	    mem->bp, mem->size, mem->flags, (kmflags == KM_SLEEP) ?
+	    DDI_DMA_SLEEP : DDI_DMA_DONTWAIT, NULL, &mem->cookie,
+	    &mem->cookie_count);
 
-	if (rval == DDI_DMA_MAPPED) {
-		if (mem->cookie_count > cnt) {
+	if (mem->memflags == DDI_DMA_MAPPED) {
+		if (mem->cookie_count > mem->max_cookie_count) {
 			(void) ddi_dma_unbind_handle(mem->dma_handle);
 			EL(ha, "failed, cookie_count %d > %d\n",
-			    mem->cookie_count, cnt);
-			rval = DDI_DMA_TOOBIG;
+			    mem->cookie_count, mem->max_cookie_count);
+			mem->memflags = (uint32_t)DDI_DMA_TOOBIG;
 		} else {
 			if (mem->cookie_count > 1) {
 				if (mem->cookies = kmem_zalloc(
 				    sizeof (ddi_dma_cookie_t) *
-				    mem->cookie_count, sleep)) {
+				    mem->cookie_count, kmflags)) {
 					*mem->cookies = mem->cookie;
 					cookiep = mem->cookies;
 					for (cnt = 1; cnt < mem->cookie_count;
@@ -15846,7 +16934,8 @@
 					(void) ddi_dma_unbind_handle(
 					    mem->dma_handle);
 					EL(ha, "failed, kmem_zalloc\n");
-					rval = DDI_DMA_NORESOURCES;
+					mem->memflags = (uint32_t)
+					    DDI_DMA_NORESOURCES;
 				}
 			} else {
 				/*
@@ -15861,14 +16950,14 @@
 		}
 	}
 
-	if (rval != DDI_DMA_MAPPED) {
-		EL(ha, "failed=%xh\n", rval);
+	if (mem->memflags != DDI_DMA_MAPPED) {
+		EL(ha, "failed=%xh\n", mem->memflags);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
-	return (rval);
+	return (mem->memflags);
 }
 
 /*
@@ -15889,9 +16978,11 @@
 static void
 ql_unbind_dma_buffer(ql_adapter_state_t *ha, dma_mem_t *mem)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	(void) ddi_dma_unbind_handle(mem->dma_handle);
+	if (mem->dma_handle != NULL && mem->memflags == DDI_DMA_MAPPED) {
+		(void) ddi_dma_unbind_handle(mem->dma_handle);
+	}
 	if (mem->cookie_count > 1) {
 		kmem_free(mem->cookies, sizeof (ddi_dma_cookie_t) *
 		    mem->cookie_count);
@@ -15898,18 +16989,28 @@
 		mem->cookies = NULL;
 	}
 	mem->cookie_count = 0;
+	mem->memflags = (uint32_t)DDI_DMA_NORESOURCES;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 static int
 ql_suspend_adapter(ql_adapter_state_t *ha)
 {
-	clock_t timer = 32 * drv_usectohz(1000000);
+	clock_t timer = (clock_t)(32 * drv_usectohz(1000000));
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
+	(void) ql_wait_outstanding(ha);
+
 	/*
+	 * here we are sure that there will not be any mbox interrupt.
+	 * So, let's make sure that we return back all the outstanding
+	 * cmds as well as internally queued commands.
+	 */
+	ql_halt(ha, PM_LEVEL_D0);
+
+	/*
 	 * First we will claim mbox ownership so that no
 	 * thread using mbox hangs when we disable the
 	 * interrupt in the middle of it.
@@ -15936,24 +17037,11 @@
 	ha->mailbox_flags = (uint8_t)(ha->mailbox_flags | MBX_BUSY_FLG);
 	MBX_REGISTER_UNLOCK(ha);
 
-	(void) ql_wait_outstanding(ha);
-
-	/*
-	 * here we are sure that there will not be any mbox interrupt.
-	 * So, let's make sure that we return back all the outstanding
-	 * cmds as well as internally queued commands.
-	 */
-	ql_halt(ha, PM_LEVEL_D0);
-
 	if (ha->power_level != PM_LEVEL_D3) {
 		/* Disable ISP interrupts. */
-		WRT16_IO_REG(ha, ictrl, 0);
+		ql_disable_intr(ha);
 	}
 
-	ADAPTER_STATE_LOCK(ha);
-	ha->flags &= ~INTERRUPTS_ENABLED;
-	ADAPTER_STATE_UNLOCK(ha);
-
 	MBX_REGISTER_LOCK(ha);
 	/* Reset busy status. */
 	ha->mailbox_flags = (uint8_t)(ha->mailbox_flags & ~MBX_BUSY_FLG);
@@ -15967,7 +17055,7 @@
 	/* Release mailbox register lock. */
 	MBX_REGISTER_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -15987,6 +17075,10 @@
 void
 ql_add_link_b(ql_head_t *head, ql_link_t *link)
 {
+	if (link->head != NULL) {
+		EL(NULL, "link in use by list=%ph\n", link->head);
+	}
+
 	/* at the end there isn't a next */
 	link->next = NULL;
 
@@ -16015,6 +17107,9 @@
 void
 ql_add_link_t(ql_head_t *head, ql_link_t *link)
 {
+	if (link->head != NULL) {
+		EL(NULL, "link in use by list=%ph\n", link->head);
+	}
 	link->prev = NULL;
 
 	if ((link->next = head->first) == NULL)	{
@@ -16034,7 +17129,7 @@
  * Input:
  *	head = Head of link list.
  *	link = link to be removed.
- *	LOCK must be already obtained.
+ *	associated proper LOCK must be already obtained.
  *
  * Context:
  *	Interrupt or Kernel context, no mailbox commands allowed.
@@ -16042,21 +17137,23 @@
 void
 ql_remove_link(ql_head_t *head, ql_link_t *link)
 {
-	if (link->prev != NULL) {
-		if ((link->prev->next = link->next) == NULL) {
-			head->last = link->prev;
+	if (head != NULL) {
+		if (link->prev != NULL) {
+			if ((link->prev->next = link->next) == NULL) {
+				head->last = link->prev;
+			} else {
+				link->next->prev = link->prev;
+			}
+		} else if ((head->first = link->next) == NULL) {
+			head->last = NULL;
 		} else {
-			link->next->prev = link->prev;
+			head->first->prev = NULL;
 		}
-	} else if ((head->first = link->next) == NULL) {
-		head->last = NULL;
-	} else {
-		head->first->prev = NULL;
-	}
 
-	/* not on a queue any more */
-	link->prev = link->next = NULL;
-	link->head = NULL;
+		/* not on a queue any more */
+		link->prev = link->next = NULL;
+		link->head = NULL;
+	}
 }
 
 /*
@@ -16074,8 +17171,8 @@
 ql_chg_endian(uint8_t buf[], size_t size)
 {
 	uint8_t byte;
-	size_t  cnt1;
-	size_t  cnt;
+	size_t	cnt1;
+	size_t	cnt;
 
 	cnt1 = size - 1;
 	for (cnt = 0; cnt < size / 2; cnt++) {
@@ -16145,7 +17242,8 @@
 void
 ql_delay(ql_adapter_state_t *ha, clock_t usecs)
 {
-	if (QL_DAEMON_SUSPENDED(ha) || ddi_in_panic()) {
+	if (ha->flags & ADAPTER_SUSPENDED || ddi_in_panic() ||
+	    curthread->t_flag & T_INTR_THREAD) {
 		drv_usecwait(usecs);
 	} else {
 		delay(drv_usectohz(usecs));
@@ -16171,27 +17269,39 @@
 ql_stall_driver(ql_adapter_state_t *ha, uint32_t options)
 {
 	ql_link_t		*link;
-	ql_adapter_state_t	*ha2;
+	ql_adapter_state_t	*ha2 = NULL;
 	uint32_t		timer;
 
-	QL_PRINT_3(CE_CONT, "started\n");
+	QL_PRINT_3(ha, "started\n");
 
-	/* Wait for 30 seconds for daemons unstall. */
-	timer = 3000;
+	/* Tell all daemons to stall. */
 	link = ha == NULL ? ql_hba.first : &ha->hba;
-	while (link != NULL && timer) {
+	while (link != NULL) {
 		ha2 = link->base_address;
 
 		ql_awaken_task_daemon(ha2, NULL, DRIVER_STALL, 0);
 
+		link = ha == NULL ? link->next : NULL;
+	}
+
+	/* Wait for 30 seconds for daemons stall. */
+	timer = 3000;
+	link = ha == NULL ? ql_hba.first : &ha->hba;
+	while (link != NULL && timer) {
+		ha2 = link->base_address;
+
 		if ((ha2->task_daemon_flags & TASK_DAEMON_ALIVE_FLG) == 0 ||
 		    (ha2->task_daemon_flags & TASK_DAEMON_STOP_FLG) != 0 ||
+		    (ha2->task_daemon_flags & FIRMWARE_UP) == 0 ||
 		    (ha2->task_daemon_flags & TASK_DAEMON_STALLED_FLG &&
-		    ql_wait_outstanding(ha2) == MAX_OUTSTANDING_COMMANDS)) {
+		    ql_wait_outstanding(ha2) == ha2->pha->osc_max_cnt)) {
 			link = ha == NULL ? link->next : NULL;
 			continue;
 		}
 
+		QL_PRINT_2(ha2, "status, dtf=%xh, stf=%xh\n",
+		    ha2->task_daemon_flags, ha2->flags);
+
 		ql_delay(ha2, 10000);
 		timer--;
 		link = ha == NULL ? ql_hba.first : &ha->hba;
@@ -16207,7 +17317,7 @@
 		return (QL_FUNCTION_TIMEOUT);
 	}
 
-	QL_PRINT_3(CE_CONT, "done\n");
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -16229,7 +17339,7 @@
 	ql_adapter_state_t	*ha2;
 	uint32_t		timer;
 
-	QL_PRINT_3(CE_CONT, "started\n");
+	QL_PRINT_3(ha, "started\n");
 
 	/* Tell all daemons to unstall. */
 	link = ha == NULL ? ql_hba.first : &ha->hba;
@@ -16250,15 +17360,13 @@
 		if ((ha2->task_daemon_flags & TASK_DAEMON_ALIVE_FLG) == 0 ||
 		    (ha2->task_daemon_flags & TASK_DAEMON_STOP_FLG) != 0 ||
 		    (ha2->task_daemon_flags & TASK_DAEMON_STALLED_FLG) == 0) {
-			QL_PRINT_2(CE_CONT, "(%d,%d): restarted\n",
-			    ha2->instance, ha2->vp_index);
+			QL_PRINT_2(ha2, "restarted\n");
 			ql_restart_queues(ha2);
 			link = ha == NULL ? link->next : NULL;
 			continue;
 		}
 
-		QL_PRINT_2(CE_CONT, "(%d,%d): failed, tdf=%xh\n",
-		    ha2->instance, ha2->vp_index, ha2->task_daemon_flags);
+		QL_PRINT_2(ha2, "status, tdf=%xh\n", ha2->task_daemon_flags);
 
 		ql_delay(ha2, 10000);
 		timer--;
@@ -16265,7 +17373,7 @@
 		link = ha == NULL ? ql_hba.first : &ha->hba;
 	}
 
-	QL_PRINT_3(CE_CONT, "done\n");
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -16289,7 +17397,7 @@
 	int32_t		i;
 	int32_t		itypes = 0;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/*
 	 * The Solaris Advanced Interrupt Functions (aif) are only
@@ -16336,8 +17444,12 @@
 	if (rval != DDI_SUCCESS) {
 		EL(ha, "failed, aif, rval=%xh\n", rval);
 	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n");
+		/* Setup mutexes */
+		if ((rval = ql_init_mutex(ha)) != DDI_SUCCESS) {
+			EL(ha, "failed, mutex init ret=%xh\n", rval);
+			ql_release_intr(ha);
+		}
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -16359,14 +17471,14 @@
 static int
 ql_setup_msi(ql_adapter_state_t *ha)
 {
+	uint_t		i;
 	int32_t		count = 0;
 	int32_t		avail = 0;
 	int32_t		actual = 0;
 	int32_t		msitype = DDI_INTR_TYPE_MSI;
 	int32_t		ret;
-	ql_ifunc_t	itrfun[10] = {0};
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ql_disable_msi != 0) {
 		EL(ha, "MSI is disabled by user\n");
@@ -16374,7 +17486,7 @@
 	}
 
 	/* MSI support is only suported on 24xx HBA's. */
-	if (!(CFG_IST(ha, CFG_CTRL_24258081))) {
+	if (!CFG_IST(ha, CFG_MSI_SUPPORT)) {
 		EL(ha, "HBA does not support MSI\n");
 		return (DDI_FAILURE);
 	}
@@ -16395,7 +17507,6 @@
 
 	/* MSI requires only 1.  */
 	count = 1;
-	itrfun[0].ifunc = &ql_isr_aif;
 
 	/* Allocate space for interrupt handles */
 	ha->hsize = ((uint32_t)(sizeof (ddi_intr_handle_t)) * count);
@@ -16411,19 +17522,18 @@
 		ql_release_intr(ha);
 		return (DDI_FAILURE);
 	}
-
 	ha->intr_cnt = actual;
 
 	/* Get interrupt priority */
-	if ((ret = ddi_intr_get_pri(ha->htable[0], &ha->intr_pri)) !=
-	    DDI_SUCCESS) {
+	if ((ret = ddi_intr_get_pri(ha->htable[0], &i)) != DDI_SUCCESS) {
 		EL(ha, "failed, get_pri ret=%xh\n", ret);
 		ql_release_intr(ha);
 		return (ret);
 	}
+	ha->intr_pri = DDI_INTR_PRI(i);
 
 	/* Add the interrupt handler */
-	if ((ret = ddi_intr_add_handler(ha->htable[0], itrfun[0].ifunc,
+	if ((ret = ddi_intr_add_handler(ha->htable[0], ql_isr_aif,
 	    (caddr_t)ha, (caddr_t)0)) != DDI_SUCCESS) {
 		EL(ha, "failed, intr_add ret=%xh\n", ret);
 		ql_release_intr(ha);
@@ -16430,13 +17540,6 @@
 		return (ret);
 	}
 
-	/* Setup mutexes */
-	if ((ret = ql_init_mutex(ha)) != DDI_SUCCESS) {
-		EL(ha, "failed, mutex init ret=%xh\n", ret);
-		ql_release_intr(ha);
-		return (ret);
-	}
-
 	/* Get the capabilities */
 	(void) ddi_intr_get_cap(ha->htable[0], &ha->intr_cap);
 
@@ -16445,20 +17548,21 @@
 		if ((ret = ddi_intr_block_enable(ha->htable, ha->intr_cnt)) !=
 		    DDI_SUCCESS) {
 			EL(ha, "failed, block enable, ret=%xh\n", ret);
-			ql_destroy_mutex(ha);
 			ql_release_intr(ha);
 			return (ret);
 		}
 	} else {
-		if ((ret = ddi_intr_enable(ha->htable[0])) != DDI_SUCCESS) {
-			EL(ha, "failed, intr enable, ret=%xh\n", ret);
-			ql_destroy_mutex(ha);
-			ql_release_intr(ha);
-			return (ret);
+		for (i = 0; i < actual; i++) {
+			if ((ret = ddi_intr_enable(ha->htable[i])) !=
+			    DDI_SUCCESS) {
+				EL(ha, "failed, intr enable, ret=%xh\n", ret);
+				ql_release_intr(ha);
+				return (ret);
+			}
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
@@ -16479,16 +17583,15 @@
 static int
 ql_setup_msix(ql_adapter_state_t *ha)
 {
-	uint16_t	hwvect;
+	int		hwvect;
 	int32_t		count = 0;
 	int32_t		avail = 0;
 	int32_t		actual = 0;
 	int32_t		msitype = DDI_INTR_TYPE_MSIX;
 	int32_t		ret;
-	uint32_t	i;
-	ql_ifunc_t	itrfun[QL_MSIX_MAXAIF] = {0};
+	uint_t		i;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ql_disable_msix != 0) {
 		EL(ha, "MSI-X is disabled by user\n");
@@ -16495,22 +17598,23 @@
 		return (DDI_FAILURE);
 	}
 
+#ifdef __x86
+	if (get_hwenv() == HW_VMWARE) {
+		EL(ha, "running under hypervisor, disabling MSI-X\n");
+		return (DDI_FAILURE);
+	}
+#endif
+
 	/*
 	 * MSI-X support is only available on 24xx HBA's that have
 	 * rev A2 parts (revid = 3) or greater.
 	 */
-	if (!((ha->device_id == 0x2532) || (ha->device_id == 0x2432) ||
-	    (ha->device_id == 0x8432) || (ha->device_id == 0x8001) ||
-	    (ha->device_id == 0x8021))) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1) ||
+	    (CFG_IST(ha, CFG_CTRL_24XX) && ha->rev_id < 3)) {
 		EL(ha, "HBA does not support MSI-X\n");
 		return (DDI_FAILURE);
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_2422) && (ha->rev_id < 3)) {
-		EL(ha, "HBA does not support MSI-X (revid)\n");
-		return (DDI_FAILURE);
-	}
-
 	/* Per HP, these HP branded HBA's are not supported with MSI-X */
 	if (ha->ven_id == 0x103C && (ha->subsys_id == 0x7041 ||
 	    ha->subsys_id == 0x7040 || ha->subsys_id == 0x1705)) {
@@ -16518,25 +17622,13 @@
 		return (DDI_FAILURE);
 	}
 
-	/* Get the number of 24xx/25xx MSI-X h/w vectors */
-	hwvect = (uint16_t)(((CFG_IST(ha, CFG_CTRL_2422) ?
-	    ql_pci_config_get16(ha, 0x7e) :
-	    ql_pci_config_get16(ha, 0xa2)) & 0x3ff) + 1);
-
-	EL(ha, "pcie config space hwvect = %d\n", hwvect);
-
-	if (hwvect < QL_MSIX_MAXAIF) {
-		EL(ha, "failed, min h/w vectors req'd: %d, avail: %d\n",
-		    QL_MSIX_MAXAIF, hwvect);
-		return (DDI_FAILURE);
-	}
-
 	/* Get number of MSI-X interrupts the platform h/w supports */
-	if (((ret = ddi_intr_get_nintrs(ha->dip, msitype, &count)) !=
-	    DDI_SUCCESS) || count == 0) {
-		EL(ha, "failed, nintrs ret=%xh, cnt=%xh\n", ret, count);
+	if (((ret = ddi_intr_get_nintrs(ha->dip, msitype, &hwvect)) !=
+	    DDI_SUCCESS) || hwvect == 0) {
+		EL(ha, "failed, nintrs ret=%xh, cnt=%xh\n", ret, hwvect);
 		return (DDI_FAILURE);
 	}
+	QL_PRINT_10(ha, "ddi_intr_get_nintrs, hwvect=%d\n", hwvect);
 
 	/* Get number of available system interrupts */
 	if (((ret = ddi_intr_get_navail(ha->dip, msitype, &avail)) !=
@@ -16544,19 +17636,21 @@
 		EL(ha, "failed, navail ret=%xh, avail=%xh\n", ret, avail);
 		return (DDI_FAILURE);
 	}
+	QL_PRINT_10(ha, "ddi_intr_get_navail, avail=%d\n", avail);
 
 	/* Fill out the intr table */
-	count = QL_MSIX_MAXAIF;
-	itrfun[QL_MSIX_AIF].ifunc = &ql_isr_aif;
-	itrfun[QL_MSIX_RSPQ].ifunc = &ql_isr_aif;
+	count = ha->interrupt_count;
+	if (ha->flags & MULTI_QUEUE && count < ha->mq_msix_vectors) {
+		count = ha->mq_msix_vectors;
+		/* don't exceed the h/w capability */
+		if (count > hwvect) {
+			count = hwvect;
+		}
+	}
 
 	/* Allocate space for interrupt handles */
 	ha->hsize = ((uint32_t)(sizeof (ddi_intr_handle_t)) * hwvect);
-	if ((ha->htable = kmem_zalloc(ha->hsize, KM_SLEEP)) == NULL) {
-		ha->hsize = 0;
-		EL(ha, "failed, unable to allocate htable space\n");
-		return (DDI_FAILURE);
-	}
+	ha->htable = kmem_zalloc(ha->hsize, KM_SLEEP);
 
 	ha->iflags |= IFLG_INTR_MSIX;
 
@@ -16563,26 +17657,28 @@
 	/* Allocate the interrupts */
 	if (((ret = ddi_intr_alloc(ha->dip, ha->htable, msitype,
 	    DDI_INTR_ALLOC_NORMAL, count, &actual, 0)) != DDI_SUCCESS) ||
-	    actual < QL_MSIX_MAXAIF) {
+	    actual < ha->interrupt_count) {
 		EL(ha, "failed, intr_alloc ret=%xh, count = %xh, "
 		    "actual=%xh\n", ret, count, actual);
 		ql_release_intr(ha);
 		return (DDI_FAILURE);
 	}
-
 	ha->intr_cnt = actual;
+	EL(ha, "min=%d, multi-q=%d, req=%d, rcv=%d\n",
+	    ha->interrupt_count, ha->mq_msix_vectors, count,
+	    ha->intr_cnt);
 
 	/* Get interrupt priority */
-	if ((ret = ddi_intr_get_pri(ha->htable[0], &ha->intr_pri)) !=
-	    DDI_SUCCESS) {
+	if ((ret = ddi_intr_get_pri(ha->htable[0], &i)) != DDI_SUCCESS) {
 		EL(ha, "failed, get_pri ret=%xh\n", ret);
 		ql_release_intr(ha);
 		return (ret);
 	}
+	ha->intr_pri = DDI_INTR_PRI(i);
 
 	/* Add the interrupt handlers */
 	for (i = 0; i < actual; i++) {
-		if ((ret = ddi_intr_add_handler(ha->htable[i], itrfun[i].ifunc,
+		if ((ret = ddi_intr_add_handler(ha->htable[i], ql_isr_aif,
 		    (void *)ha, (void *)((ulong_t)i))) != DDI_SUCCESS) {
 			EL(ha, "failed, addh#=%xh, act=%xh, ret=%xh\n", i,
 			    actual, ret);
@@ -16604,41 +17700,39 @@
 			ql_release_intr(ha);
 			return (ret);
 		}
+		if ((ret = ddi_intr_enable(ha->htable[i])) != DDI_SUCCESS) {
+			EL(ha, "failed, intr enable, ret=%xh\n", ret);
+			ql_release_intr(ha);
+			return (ret);
+		}
 	}
 #endif
 
-	/* Setup mutexes */
-	if ((ret = ql_init_mutex(ha)) != DDI_SUCCESS) {
-		EL(ha, "failed, mutex init ret=%xh\n", ret);
-		ql_release_intr(ha);
-		return (ret);
-	}
-
 	/* Get the capabilities */
 	(void) ddi_intr_get_cap(ha->htable[0], &ha->intr_cap);
 
 	/* Enable interrupts */
 	if (ha->intr_cap & DDI_INTR_FLAG_BLOCK) {
-		if ((ret = ddi_intr_block_enable(ha->htable, ha->intr_cnt)) !=
+		if ((ret = ddi_intr_block_enable(ha->htable, actual)) !=
 		    DDI_SUCCESS) {
 			EL(ha, "failed, block enable, ret=%xh\n", ret);
-			ql_destroy_mutex(ha);
 			ql_release_intr(ha);
 			return (ret);
 		}
+		QL_PRINT_10(ha, "intr_block_enable %d\n", actual);
 	} else {
-		for (i = 0; i < ha->intr_cnt; i++) {
+		for (i = 0; i < actual; i++) {
 			if ((ret = ddi_intr_enable(ha->htable[i])) !=
 			    DDI_SUCCESS) {
 				EL(ha, "failed, intr enable, ret=%xh\n", ret);
-				ql_destroy_mutex(ha);
 				ql_release_intr(ha);
 				return (ret);
 			}
+			QL_PRINT_10(ha, "intr_enable %d\n", i);
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
@@ -16662,10 +17756,15 @@
 	int32_t		count = 0;
 	int32_t		actual = 0;
 	int32_t		ret;
-	uint32_t	i;
+	uint_t		i;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
+	if (ql_disable_intx != 0) {
+		EL(ha, "INT-X is disabled by user\n");
+		return (DDI_FAILURE);
+	}
+
 	/* Get number of fixed interrupts the system supports */
 	if (((ret = ddi_intr_get_nintrs(ha->dip, DDI_INTR_TYPE_FIXED,
 	    &count)) != DDI_SUCCESS) || count == 0) {
@@ -16673,12 +17772,12 @@
 		return (DDI_FAILURE);
 	}
 
-	ha->iflags |= IFLG_INTR_FIXED;
-
 	/* Allocate space for interrupt handles */
 	ha->hsize = ((uint32_t)(sizeof (ddi_intr_handle_t)) * count);
 	ha->htable = kmem_zalloc(ha->hsize, KM_SLEEP);
 
+	ha->iflags |= IFLG_INTR_FIXED;
+
 	/* Allocate the interrupts */
 	if (((ret = ddi_intr_alloc(ha->dip, ha->htable, DDI_INTR_TYPE_FIXED,
 	    0, count, &actual, DDI_INTR_ALLOC_STRICT)) != DDI_SUCCESS) ||
@@ -16688,20 +17787,19 @@
 		ql_release_intr(ha);
 		return (DDI_FAILURE);
 	}
-
 	ha->intr_cnt = actual;
 
 	/* Get interrupt priority */
-	if ((ret = ddi_intr_get_pri(ha->htable[0], &ha->intr_pri)) !=
-	    DDI_SUCCESS) {
+	if ((ret = ddi_intr_get_pri(ha->htable[0], &i)) != DDI_SUCCESS) {
 		EL(ha, "failed, get_pri ret=%xh\n", ret);
 		ql_release_intr(ha);
 		return (ret);
 	}
+	ha->intr_pri = DDI_INTR_PRI(i);
 
 	/* Add the interrupt handlers */
-	for (i = 0; i < ha->intr_cnt; i++) {
-		if ((ret = ddi_intr_add_handler(ha->htable[i], &ql_isr_aif,
+	for (i = 0; i < actual; i++) {
+		if ((ret = ddi_intr_add_handler(ha->htable[i], ql_isr_aif,
 		    (void *)ha, (void *)((ulong_t)(i)))) != DDI_SUCCESS) {
 			EL(ha, "failed, intr_add ret=%xh\n", ret);
 			ql_release_intr(ha);
@@ -16709,18 +17807,10 @@
 		}
 	}
 
-	/* Setup mutexes */
-	if ((ret = ql_init_mutex(ha)) != DDI_SUCCESS) {
-		EL(ha, "failed, mutex init ret=%xh\n", ret);
-		ql_release_intr(ha);
-		return (ret);
-	}
-
 	/* Enable interrupts */
-	for (i = 0; i < ha->intr_cnt; i++) {
+	for (i = 0; i < actual; i++) {
 		if ((ret = ddi_intr_enable(ha->htable[i])) != DDI_SUCCESS) {
 			EL(ha, "failed, intr enable, ret=%xh\n", ret);
-			ql_destroy_mutex(ha);
 			ql_release_intr(ha);
 			return (ret);
 		}
